<script setup>
import {onMounted, ref, computed} from "vue";
import { useRoute } from 'vue-router'
import AppimmoService from "../services/appimmo.service";

import Navbar from "/src/components/Navbar.vue"
import Property from "/src/components/Property.vue";

const appimmoService = AppimmoService

const currentPicture = ref(0)
const prePicture = ref(0)
const nPicture = ref(0)



const route = useRoute()
const propertyId = route.params.id
console.log(propertyId);
const property = ref()

const getProperty = async () => {
  const response = ref(await appimmoService.get('properties/' + propertyId))
  console.log(response.value.data);
  property.value = response.value.data
}

const previousPicture = () => {
  if (currentPicture.value === 0) {
    currentPicture.value = property.value.pictures.length - 1
  } else {
    currentPicture.value--
  }

}

const nextPicture = () => {
  if (currentPicture.value === property.value.pictures.length - 1) {
    currentPicture.value = 0
  } else {
    currentPicture.value++
  }

}

const thumbnailsPictures = computed(() => {
  if (currentPicture.value === 0) {
    prePicture.value = property.value.pictures.length - 1
  } else {
    prePicture.value = currentPicture.value -1
  }

  if (currentPicture.value === property.value.pictures.length - 1) {
    nPicture.value = 0
  } else {
    nPicture.value = currentPicture.value + 1
  }
})

onMounted(() => {
  getProperty()
})

</script>

<template>
  <Navbar/>

  <div v-if="property !== undefined">
    {{thumbnailsPictures}}


  <div @click.prevent="theme" class="flex flex-col gap-12 md:flex-row md:py-10 md:px-12 lg:px-20 xl:px-48 md:mb-36">
    <div class="flex flex-col md:w-2/3">
      <div>
        <div id="controls-carousel" class="relative" data-carousel="static">
          <!-- Carousel wrapper -->
          <div class="overflow-hidden relative md:rounded-t-lg h-64 md:h-48 xl:h-80 2xl:h-96">
            <!-- Item 1 -->
            <div v-if="property !== undefined" v-for="(picture, index) in property.pictures"
                 :class="index === currentPicture +1 || index <= currentPicture -2 ? 'translate-x-full absolute inset-0 z-10' : '',
               index === currentPicture -1 || index >= currentPicture +2 ? '-translate-x-full absolute inset-0 z-10' : '',
               index === currentPicture ? 'z-20' : ''"
                 class="duration-700 absolute inset-0 ease-in-out " data-carousel-item>
              <img :src="picture.url" class="block absolute top-1/2 left-1/2 w-full -translate-x-1/2 -translate-y-1/2" alt="...">
            </div>
            <!-- Slider controls -->
            <button @click="previousPicture" type="button" class="flex lg:hidden absolute top-0 left-0 z-30 justify-center items-center px-4 h-full cursor-pointer group focus:outline-none" data-carousel-prev>
        <span class="inline-flex justify-center items-center w-8 h-8 rounded-full sm:w-10 sm:h-10 bg-white/30 dark:bg-gray-800/30 group-hover:bg-white/50 dark:group-hover:bg-gray-800/60 group-focus:ring-4 group-focus:ring-white dark:group-focus:ring-gray-800/70 group-focus:outline-none">
            <svg class="w-5 h-5 text-white sm:w-6 sm:h-6 dark:text-gray-800" fill="none" stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 19l-7-7 7-7"></path></svg>
            <span class="hidden">Previous</span>
        </span>
            </button>
            <button @click="nextPicture" type="button" class="flex lg:hidden absolute top-0 right-0 z-30 justify-center items-center px-4 h-full cursor-pointer group focus:outline-none" data-carousel-next>
        <span class="inline-flex justify-center items-center w-8 h-8 rounded-full sm:w-10 sm:h-10 bg-white/30 dark:bg-gray-800/30 group-hover:bg-white/50 dark:group-hover:bg-gray-800/60 group-focus:ring-4 group-focus:ring-white dark:group-focus:ring-gray-800/70 group-focus:outline-none">
            <svg class="w-5 h-5 text-white sm:w-6 sm:h-6 dark:text-gray-800" fill="none" stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7"></path></svg>
            <span class="hidden">Next</span>
        </span>
            </button>
          </div>
        </div>
        <div>
        </div>
      </div>
      <div class="hidden lg:flex justify-around py-2 max-h-[100px] gray-bg">
        <!-- Slider controls -->
        <button @click="previousPicture" type="button" class="px-4 cursor-pointer group focus:outline-none" data-carousel-prev>
        <span class="inline-flex justify-center items-center w-10 h-10 rounded-full bg-white/30 dark:bg-gray-800/30 group-hover:bg-white/50 dark:group-hover:bg-gray-800/60 group-focus:ring-4 group-focus:ring-white dark:group-focus:ring-gray-800/70 group-focus:outline-none">
            <svg class="w-6 h-6 text-white dark:text-gray-800" fill="none" stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 19l-7-7 7-7"></path></svg>
            <span class="hidden">Previous</span>
        </span>
        </button>
          <div v-if="property !== undefined" class="thumbnails flex flex-row justify-evenly" data-carousel-item>
            <img @click="currentPicture = prePicture" :src="property.pictures[prePicture].url" class="bg-blend-luminosity" alt="...">
            <img :src="property.pictures[currentPicture].url" class="" alt="...">
            <img @click="currentPicture = nPicture" :src="property.pictures[nPicture].url" class="bg-blend-luminosity" alt="...">
          </div>


        <button @click="nextPicture" type="button" class="px-4 cursor-pointer group focus:outline-none" data-carousel-next>
        <span class="inline-flex justify-center items-center w-10 h-10 rounded-full bg-white/30 dark:bg-gray-800/30 group-hover:bg-white/50 dark:group-hover:bg-gray-800/60 group-focus:ring-4 group-focus:ring-white dark:group-focus:ring-gray-800/70 group-focus:outline-none">
            <svg class="w-6 h-6 text-white dark:text-gray-800" fill="none" stroke="currentColor" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7"></path></svg>
            <span class="hidden">Next</span>
        </span>
        </button>
      </div>
      <div class="blue-bg px-5 py-1 text-white">
        <div class="flex flex-row justify-between text-xl">
          <h1 >{{property.title}}</h1>
          <h2>{{property.price}}</h2>
        </div>
        <h2>{{property.address.city.name}}</h2>
      </div>
      <div class="p-3 gray-b border-2 bg-white rounded-b-md">
        {{property.description}}
      </div>
    </div>

    <div class="flex flex-col md:w-1/3">
      <div class=" mb-8">
        <div class="rounded-t-md blue-bg py-2 px-3">
          <h3 class="text-white">Détails</h3>
        </div>
        <div class="bg-white border-2 rounded-b-md gray-b h-[300px]">
            <h3>Pièces à vivre</h3>
            <h3>Hygiène</h3>
            <h3>Surface</h3>
            <h3>Chauffage et diagnostics</h3>
            <h3>DPE</h3>
            <h3>GES</h3>
        </div>
      </div>

      <div class="">
        <div class="rounded-t-md blue-bg py-2 px-3">
          <h3 class="text-white">Contact</h3>
        </div>
        <div class="bg-white border-2 rounded-b-md gray-b h-[300px]">
          <p>{{property.user.fullname}}</p>
          <p>{{property.user.phone}}</p>
          <p>{{property.user.email}}</p>
        </div>
      </div>
    </div>

  </div>
  </div>
</template>


<style lang="scss">
body {
  margin: 0;
  padding: 0;
  background-color: #F5F7FB;
}

@Media screen and (width > 768px) {
  body {
    margin-top: 60px;
  }
}
</style>
